package camadaDados;

import classesBasicas.*;
import exceptions.*;
import java.sql.*;
import java.util.logging.Level;
import java.util.logging.Logger;

public class RepositorioAbastece {

    private Conexao cnn;
	
	public RepositorioAbastece(Conexao cnn) {
		super();
		this.cnn = cnn;
	}

	public void inserirAbastecimento(Abastece f) throws AbasteciementoJahInserido{
               
            boolean bug = false;
            
            String query ="INSERT INTO SACIAbastece " +
                        "(PLACA , CEP , NUMERO , DATAHORA  , CUSTO , QUILOMETRAGEMATUAL, LITROSABASTECIDOS ,TIPOCOMBUSTIVEL)" + 
                        "VALUES " +
				"( '" 
					+ f.getPlaca() + "', " 
					+ f.getCep() + ", "
					+ f.getNumero() + ", "
					+ cnn.stringDataToDate(f.getDataHora() )+ ", "
					+ f.getCusto() + ", "
					+ f.getQuilometragem() + ", "
					+ f.getLitros() + ", '"
                                        + f.getCombustivel() + "')";
            System.out.println(query);
            try {
                this.cnn.getStmt().execute(query);
            } catch (SQLException ex) {
                ex.printStackTrace();
                bug = true;
                
            }
            if(bug ) throw new AbasteciementoJahInserido();
		
        }
                
        public Abastece buscarUltimoAbastecimento(String placa) throws SQLException, AbastecimentoInexistente{
            
            this.cnn.setRset ( 
                    this.cnn.getStmt().executeQuery("select * from ( SELECT PLACA , CEP , NUMERO , TO_CHAR( DATAHORA , 'DD/MM/YYYY') AS DATAHORA  , CUSTO , QUILOMETRAGEMATUAL, LITROSABASTECIDOS ,TIPOCOMBUSTIVEL " +
                    " FROM SACIAbastece WHERE PLACA = '" + placa + "' ORDER BY DATAHORA DESC ) where rownum <= 1")
            );

            Abastece f = null;          
                    
            if(this.cnn.getRset().next()){
                     f = new Abastece(
                           this.cnn.getRset().getString("PLACA"),
                           this.cnn.getRset().getInt("CEP"),
                           this.cnn.getRset().getInt("NUMERO"),
                           this.cnn.getRset().getInt("QUILOMETRAGEMATUAL"),
                           this.cnn.getRset().getString("DATAHORA"),
                           this.cnn.getRset().getString("TIPOCOMBUSTIVEL"),
                           this.cnn.getRset().getInt("LITROSABASTECIDOS"),
                           this.cnn.getRset().getInt("CUSTO")
                    );

            } else {
                    throw new AbastecimentoInexistente("Não foi possível encontrar nenhum abastecimento para esta placa");
            }
            return f;
            
        }    
        
        public int buscarQuantidadesLitrosAbastecidos(String placa) throws AbastecimentoInexistente, SQLException{
            
            this.cnn.setRset ( 
                    this.cnn.getStmt().executeQuery("select SUM( LITROSABASTECIDOS ) as SOMA " +
                    " FROM SACIAbastece WHERE PLACA = '" + placa + "' ")
            );

            int ret = 0;
                    
            if(this.cnn.getRset().next()){
                     ret = this.cnn.getRset().getInt("SOMA");
            } else {
                   throw new AbastecimentoInexistente("Não foi possível encontrar nenhum abastecimento para esta placa");
            }
            
            return ret;
        }
        
        
        
}
