package negocios;

import camadaDados.Conexao;
import camadaDados.RepositorioFuncionario;
import classesBasicas.Funcionario;
import exceptions.*;
import java.sql.SQLException;



public class UtilidadesFuncionario {
        
        private Conexao cnn;
        private RepositorioFuncionario repFunc;
        private Funcionario usuario;
        
        public UtilidadesFuncionario(Conexao cnn){
            this.cnn = cnn;
            repFunc = new RepositorioFuncionario(this.cnn);
        }
    
        
        public Funcionario buscar(String CPF) throws CPFinvalido, CPFnaoExiste{
            if (CPF.length() != 11){
                throw new CPFinvalido();
            }

            try {
                return repFunc.buscarFuncionario(CPF);
            } catch (SQLException ex) {
                ex.printStackTrace();
                return null;
            }

        }
        
	public boolean logar(String loginCPF, String senha) throws CPFinvalido, SenhaInvalida, CPFnaoExiste, SQLException{
		if (loginCPF.length() != 11){
			throw new CPFinvalido();
		}
                try{
                    usuario = repFunc.buscarFuncionario(loginCPF);
                    
                    if ( !usuario.getSenha().equals(senha) ) throw new SenhaInvalida();
                    
                    usuario.setLogado(true);
                }
                catch(CPFnaoExiste e1){
                    throw new CPFnaoExiste();
                }
                catch(SQLException e2){
                    e2.printStackTrace();
                    throw new SQLException();
                }
                return true;
	}
	
	public boolean deslogar() throws Exception{		
		if ( !this.usuario.getLogado() ) throw new Exception("Usuário não está logado!");
                
                this.usuario.setLogado(false);
                
                return true;
	}
	
	public boolean cadastrar(  String Cpf,
                                String Cargo,
				String TipoCNH,
				String Senha,
				int EhAdmin,
				String data_nascimento,
				int Identidade,
                                String nome) throws CPFinvalido, CNHinvalida, RGinvalido, SenhaInvalida, CPFexistente{
		
		if (Cpf.length() != 11){
			throw new CPFinvalido();
		}
		
		if (!(TipoCNH == null || TipoCNH.equals("A")  || TipoCNH.equals("AB")  || TipoCNH.equals("ACC")  || TipoCNH.equals("B")  || TipoCNH.equals("C")  || TipoCNH.equals("D")  || TipoCNH.equals("E"))){
			throw new CNHinvalida();
		}
		
		String auxID = "" + Identidade;
		
		if (auxID.length() != 7){
			throw new RGinvalido();
		}
		
		if (Senha.length() < 4){
			throw new SenhaInvalida();
		}
                try{
                    Funcionario aux = repFunc.buscarFuncionario(Cpf);
                    
                    throw new CPFexistente();
                }               
                catch (CPFnaoExiste e1){
                    try{
                    Funcionario func = new Funcionario(Cpf, Cargo, TipoCNH, Senha, EhAdmin, data_nascimento, Identidade, nome);
                    
                    repFunc.inserirFucionario(func);
                    }
                    catch(Exception e2){
                        return false;
                    }
                }
                catch(SQLException e){
                    e.printStackTrace();
                    return false;
                }
                
                return true;
	}
	
	public boolean descadastrar(String loginCPF) throws CPFinvalido, CPFnaoExiste{
		if (loginCPF.length() != 11){
			throw new CPFinvalido();
		}
		
                try{
                    Funcionario func = repFunc.buscarFuncionario(loginCPF);
                    
                    repFunc.descadastrarFuncionario(loginCPF);
                }
                catch (SQLException e2){
                    return false;
                }
                
                return true;
	}

        public Funcionario getUsuario(){ return this.usuario; }
        
}
